# *game* — a game boy advance game

Currently under development, with very few current updates here. See my
[blog][1] for updates, with it mirrored on gemini
(<gemini://tilde.team/~nytpu/blog/>) and gopher
(<gopher://tilde.team:70/1/~nytpu/blog>), with all game-related posts under the
heading `making-a-gba-game`.

I will update this README when more progress is made.


## building
I'm preparing for the future here, by writing everything I know now, but this
may change later as I work on the code

### dependencies
You can [follow the instructions][bld-1] to install DevKitARM and that should
provide you with all of the unusual or nonstandard tools you need. However,
I'll enumerate the specific tools you need if you want to install them
individually:

* Proper environment variables set up for `$DEVKITPRO` and `$DEVKITARM`
		pointing towards the correct install locations
* `grit` — for converting exported maps or tilesets to `.h` and `.c` files for
		use in the game
* `portlibs` installed to `$DEVKITPRO/portlibs`
* `libtonc` installed to `$DEVKITPRO/libtonc`
* Working installations of all `arm-none-eabi-` tools
* ...seriously, just install DevKitARM because everything weird is installed,
		and I'm not sure if I even listed everything needed here
* `sed` — used in the makefiles
* `make` — used to make the darn thing
* Aseprite — optional, for editing the sprites
* mgba — optional, used for debugging and testing

**Note: the instructions don't really work yet because I have literally no code
for the game, but right now it will range from not working to displaying 3
beautifully colored RGB pixels**  

Clone the repo and checkout the most recent release:

```
git clone https://tildegit.org/nytpu/game.git
cd game
git checkout $(git describe --tags --abbrev=0)
make
```
You should get `game.gba` spat out in the project root. You can then run that
on your flashcart or in an emulator and it should just work™.

## special thanks to:
* [cearn][stt-1] for his wonderful [tonclib][stt-2] as well as his very
		in-depth and useful [tonc tutorial][stt-3]. Without these tools and
		references, I would have been totally unable to make anything like this.
* [DevKitPro][stt-4] for their amazing [DevKitARM][stt-5] toolchain, complete
		with a custom `libc` and `gcc`, without which I wouldn't have even
		thought of attempting anything with the GBA.

## copyright
I'm not worried about Nintendo doing anything because they only bring action
against people who pirate their games or who make fan games with their IP, like
Pokémon fan games (I'll leave my defense of fair use for another time), not
omebrew devs making original games. However, if Nintendo sees any legal issues
with this game, please contact me at <nytpu@tilde.team> before contacting
tildegit and I will take down this repository or take any other action
requested.

This project, including artwork, sound, etc. is dual-licensed under the
Unlicense and the MIT License, and you can use the project under the terms of
either license. For more details, see COPYING.

[1]: https://tilde.team/~nytpu/blog/tag_gbagame.html

[bld-1]: https://devkitpro.org/wiki/Getting_Started/devkitARM

[stt-1]: http://www.coranac.com/
[stt-2]: http://www.coranac.com/projects/tonc/
[stt-3]: http://www.coranac.com/tonc/text/toc.htm
[stt-4]: https://devkitpro.org/wiki/about
[stt-5]: https://devkitpro.org/wiki/devkitarm
